﻿@using System.Web.UI.WebControls;
@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using DevExpress.Utils;
@using Portal.Models.Delivery.Invoice;
@using Toyota.Common.Web.Html;
@using Toyota.Common.Web.Html.Helper
@using Toyota.Common.Web.MVC;

@Html.Common().DevExpress().GridView(
setting =>
{
    setting.Name = "DJTransGrid";
    setting.Width = Unit.Percentage(100);
    setting.Settings.ShowFilterRow = true;
    setting.Settings.ShowFilterRowMenu = true;
    setting.Settings.ShowColumnHeaders = true;
    setting.KeyFieldName = "DATA_KEY"; //DOC_NO;DOC_YEAR;DOC_ITEM;DOC_DT

    setting.CallbackRouteValues = new { Controller = "D31408", Action = "JournalTransTab" };
    setting.ClientSideEvents.BeginCallback = "OnBeginCallbackGridTransData";
    //setting.ClientSideEvents.EndCallback = "OnEndCallbackGrid";
    //setting.ClientSideEvents.Init = "GridDeliveryInvoiceAndPay_Init";
    setting.SettingsBehavior.AllowSelectSingleRowOnly = false;
    setting.SettingsBehavior.AllowSelectByRowClick = true;

    setting.Settings.HorizontalScrollBarMode = ScrollBarMode.Visible;
    setting.Settings.VerticalScrollBarMode = ScrollBarMode.Hidden;
    setting.Styles.Header.HorizontalAlign = HorizontalAlign.Center;
    setting.Styles.Header.VerticalAlign = VerticalAlign.Middle;

    setting.SettingsPager.FirstPageButton.Visible = true;
    setting.SettingsPager.LastPageButton.Visible = true;
    setting.SettingsPager.ShowNumericButtons = true;
    //setting.Settings.HorizontalScrollBarMode = ScrollBarMode.Hidden;
    setting.SettingsPager.Position = PagerPosition.Bottom;
    setting.SettingsPager.PageSizeItemSettings.Visible = true;
    setting.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100" };
    setting.SettingsPager.PageSizeItemSettings.Caption = "Page size";

    setting.CommandColumn.Visible = true;
    setting.CommandColumn.Width = Unit.Pixel(40);
    setting.CommandColumn.ClearFilterButton.Visible = true;
    setting.CommandColumn.ShowSelectCheckbox = true;

    if (setting.SettingsBehavior.AllowSelectSingleRowOnly == false)
    {
        setting.CommandColumn.SetHeaderTemplateContent(
        c =>
        {
            Html.DevExpress().CheckBox(settingsCheckBox =>
            {
                settingsCheckBox.Name = "DJTransCheckBox";
                settingsCheckBox.Properties.ClientSideEvents.CheckedChanged = string.Format("function(s, e) {{ if(s.GetChecked()) {0}.SelectRows(); else {0}.UnselectRows(); }}", setting.Name);
                settingsCheckBox.Checked = (c.Grid.Selection.Count == c.Grid.VisibleRowCount) && (c.Grid.Selection.Count > 0);
            }).Render();
        });
    }

    setting.CustomJSProperties = (s, e) =>
    {
        MVCxGridView grid = (MVCxGridView)s;
        int startIndex = grid.PageIndex * grid.SettingsPager.PageSize;
        int end = Math.Min(grid.VisibleRowCount, startIndex + grid.SettingsPager.PageSize);
        object[] Document_No = new object[end - startIndex];
        object[] Document_Year = new object[end - startIndex];
        object[] Document_Date = new object[end - startIndex];
        object[] Document_Item_No = new object[end - startIndex];

        for (int n = startIndex; n < end; n++)
        {
            Document_No[n - startIndex] = grid.GetRowValues(n, "DOC_NO");
            Document_Year[n - startIndex] = grid.GetRowValues(n, "DOC_YEAR");
            Document_Date[n - startIndex] = grid.GetRowValues(n, "DOC_DT");
            Document_Item_No[n - startIndex] = grid.GetRowValues(n, "DOC_ITEM");
        }
        
        e.Properties["cpDocument_No"] = Document_No;
        e.Properties["cpDocument_Year"] = Document_Year;
        e.Properties["cpDocument_Date"] = Document_Date;
        e.Properties["cpDocument_Item_No"] = Document_Item_No;
        grid.JSProperties["cpPageSize"] = grid.SettingsPager.PageSize;
    };

    setting.Columns.Add(col =>
    {
        col.FieldName = "DOC_NO";
        col.Caption = "Document No";
        col.Width = Unit.Pixel(150);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "DOC_YEAR";
        col.Caption = "Document Year";
        col.Width = Unit.Pixel(100);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "DOC_ITEM";
        col.Caption = "Document Item";
        col.Width = Unit.Pixel(100);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "DOC_DT";
        col.Caption = "Document Date";
        col.Width = Unit.Pixel(100);
        col.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy";
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "TRANSACTION_CD";
        col.Caption = "Transaction CD.";
        col.Width = Unit.Pixel(100);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "CONDITION_TYPE";
        col.Caption = "Condition Type";
        col.Width = Unit.Pixel(100);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Left;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "DEBIT_CREDIT_INDICATOR";
        col.Caption = "Debit-Credit Indicator";
        col.Width = Unit.Pixel(150);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "GL_ACCOUNT";
        col.Caption = "GL Account";
        col.Width = Unit.Pixel(100);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "ROUTE_CD";
        col.Caption = "Route CD.";
        col.Width = Unit.Pixel(100);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "QTY";
        col.Caption = "Quantity";
        col.Width = Unit.Pixel(100);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "AMT_DOC";
        col.Caption = "Amount Doc.";
        col.Width = Unit.Pixel(100);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Right;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "DOC_CURR";
        col.Caption = "Document Curr.";
        col.Width = Unit.Pixel(100);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "AMT_LOCAL";
        col.Caption = "Local Amount";
        col.Width = Unit.Pixel(100);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Right;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "LOCAL_CURR";
        col.Caption = "Local Currency";
        col.Width = Unit.Pixel(100);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "PO_NO";
        col.Caption = "PO No.";
        col.Width = Unit.Pixel(100);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "TAX_CD";
        col.Caption = "Tax CD.";
        col.Width = Unit.Pixel(100);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "EXCHANGE_RATE";
        col.Caption = "Exchange Rate";
        col.Width = Unit.Pixel(100);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Right;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "COST_CENTER_CD";
        col.Caption = "Cost Center";
        col.Width = Unit.Pixel(100);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "DOC_TYPE";
        col.Caption = "Document Type";
        col.Width = Unit.Pixel(100);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "GL_BALANCE_FLAG";
        col.Caption = "GL Balance Flag";
        col.Width = Unit.Pixel(100);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "WBS_NO";
        col.Caption = "WBS No.";
        col.Width = Unit.Pixel(200);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "UOM";
        col.Caption = "UOM";
        col.Width = Unit.Pixel(100);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "ITEM_TEXT";
        col.Caption = "Item Text";
        col.Width = Unit.Pixel(120);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "PROCESS_ID";
        col.Caption = "Process ID";
        col.Width = Unit.Pixel(100);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "POSTING_STS";
        col.Caption = "Posting Status";
        col.Width = Unit.Pixel(120);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "CREATED_BY";
        col.Caption = "Created By";
        col.Width = Unit.Pixel(100);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "CREATED_DT";
        col.Caption = "Created Date";
        col.Width = Unit.Pixel(100);
        col.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy";
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "CHANGED_BY";
        col.Caption = "Changed By";
        col.Width = Unit.Pixel(100);
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.Columns.Add(col =>
    {
        col.FieldName = "CHANGED_DT";
        col.Caption = "Changed Date";
        col.Width = Unit.Pixel(100);
        col.PropertiesEdit.DisplayFormatString = "dd.MM.yyyy";
        col.HeaderStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.HorizontalAlign = HorizontalAlign.Center;
        col.CellStyle.VerticalAlign = VerticalAlign.Middle;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
    });

    setting.CustomColumnDisplayText = (sender, e) =>
    {
        if ((e.Column.FieldName == "CREATED_DT") || (e.Column.FieldName == "CHANGED_DT"))
        {
            string formattedDate = String.Format("{0:dd.MM.yyyy}", e.Value);
            if ((formattedDate == "01.01.0001") || (formattedDate == "01.01.1900")) e.DisplayText = "";
            else e.DisplayText = formattedDate;
        }
    };

    setting.HtmlRowPrepared = (s, e) =>
    {
        if (e.GetValue("POSTING_STS") != null)
        {
            if (e.GetValue("POSTING_STS").ToString() == "ERROR POSTING")
                e.Row.BackColor = System.Drawing.Color.Red;

            if (e.GetValue("POSTING_STS").ToString() == "IN PROGRESS")
                e.Row.BackColor = System.Drawing.Color.Yellow;
        }
    };
    
}).Bind(Model.GetModel<Portal.Models.Delivery.Invoice.DeliveryJournalData>().DJTransData).GetHtml()

